function val = IsaacDATA_get(obj,propname)
% @IsaacDATA : lecture d'une proprit
%
% propname		val
% --------		---
% 'Class'		obj.dataclass
% 'Info'       obj.datainfo
% 'Type'       obj.datatype
% 'TypeInfo'	descriptif par dfaut de obj.datatype
% 'TypeValues'	cellarray des valeurs possibles de obj.datatype
% 'Val'			obj.dataval
% 'ValStr'		chane de caractres correspondant  obj.dataval
%
% OpenIsaac
%  2018 Alain Clment - Universit d'Angers

%---------------------------------------------------------------------------------------------------

% Copyright 2007 - 2018 Universit d'Angers - Author: Alain Clment
%
% This program is free software; you can redistribute it and/or modify it under the terms of the GNU
% General Public License as published by the Free Software Foundation; either version 3 of the
% License, or any later version. This program is distributed in the hope that it will be useful, but
% WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
% PARTICULAR PURPOSE. See the GNU General Public License for more details. You should have received
% a copy of the GNU General Public License along with this program; if not, write to the Free
% Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

%---------------------------------------------------------------------------------------------------

switch propname
	case 'Class'
		val = obj.dataclass;
	case 'Info'
		val = obj.datainfo;
	case 'Type'
		val = obj.datatype;
	case 'TypeInfo'
		switch obj.datatype
		case 'VALL'
			val ='valeur logical';
		case 'TABL'
			val ='matrice logical de dimensions quelconques';
		case 'VALN'
			val ='valeur numrique';
		case 'TABN'
			val ='matrice numrique de dimensions quelconques';
		case 'VALA'
			val ='chane ASCII';
		case 'TABA'
			val ='cell array de chanes ASCII de dimensions quelconques';
		case 'VALX'
			val ='valeur de classe quelconque';
		case 'TABX'
			val ='cell array de contenu et dimensions quelconques';
		case 'NFIC'
			val ='nom complet d''un fichier';
		case 'LFIC'
			val ='cell array {n,1} de noms de fichiers';
		case 'NREP'
			val ='nom complet de rpertoire';
		end
	case 'TypeValues'
		val = {'VALL';'TABL';'VALN';'TABN';'VALA';'TABA';'VALX';'TABX';
			'NFIC';'LFIC';'NREP'};
	case 'Val'
		val = obj.dataval;
	case 'ValStr'
		switch obj.datatype
		case {'VALL','VALN'}
			val = num2str(obj.dataval);
		case {'TABL','TABN'}
			val = mat2str(obj.dataval);
		case {'VALA','TABA'}
			val = obj.dataval;
		case 'VALX'
         if verLessThan('matlab', '7.11') 
            % code pour MATLAB 2010a et antrieur
            test_mat = (ndims(obj.dataval) == 2);                                               %#ok
         else
            % code pour MATLAB 2010b (7.11) et postrieur  
            test_mat = ismatrix(obj.dataval);
         end
			if (isa(obj.dataval,'numeric') || isa(obj.dataval,'logical'))
				if (test_mat && (size(obj.dataval,1) <= 1) && (size(obj.dataval,2) <= 1))
					val = num2str(obj.dataval);
				else
					val = mat2str(obj.dataval);
				end	
			elseif (test_mat && isa(obj.dataval,'char') && (size(obj.dataval,1) <= 1))
				val = obj.dataval;
			else
				val = evalc('disp(obj.dataval)');
% 				if isempty(val)
% 					val = ['contenu <',class(obj.dataval),'>'];
% 				end	
			end	
		case 'TABX'
			val = evalc('disp(obj.dataval)');
		case {'NFIC','NREP'}
			val = IsaacPathStr(obj.dataval,2);	
		case 'LFIC'
			n = size(obj.dataval,1);
			val = {};
			for i = 1:n
				val{i} = IsaacPathStr(obj.dataval{i},2);                                            %#ok
			end	
		end	
	otherwise
		error('argument incorrect')
end