function [bitclass,nbplans] = IsaacColorType(colorspacename)
% Dtermine le nb de bits et le nb de plans requis par un espace colorimtrique non ICC
% (compatibilit des transformations makecform(type) avec MATLAB 2007a)
%
% - bitclass : classe(s) de bits autorise(s) pour l'image (8/16/32/64) ou [] si espace non gr
% - nbplans	 : dimension de l'espace colorimtrique ou 0 si espace non gr
%
% OpenIsaac
%  2018 Alain Clment - Universit d'Angers

%---------------------------------------------------------------------------------------------------

% Copyright 2007 - 2018 Universit d'Angers - Author: Alain Clment
%
% This program is free software; you can redistribute it and/or modify it under the terms of the GNU
% General Public License as published by the Free Software Foundation; either version 3 of the
% License, or any later version. This program is distributed in the hope that it will be useful, but
% WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
% PARTICULAR PURPOSE. See the GNU General Public License for more details. You should have received
% a copy of the GNU General Public License along with this program; if not, write to the Free
% Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

%---------------------------------------------------------------------------------------------------

                                                                                         %[tomodify]
% conversion LCH (double) supprime car rsultats plan H entre 50 et 500 (bug Matlab 2007a ?)

if isempty(colorspacename)
	bitclass = [];
	nbplans = 0;
	return
end
switch colorspacename
	case 'SRGB'
		bitclass = [8,16,64];
		nbplans = 3;
	case 'XYZ'
		bitclass = [16,64];
		nbplans = 3;
	case 'XYL'
		bitclass = 64;
		nbplans = 3;
	case 'LAB'
		bitclass = [8,16,64];
		nbplans = 3;
% 	case 'LCH'
% 		bitclass = 64;
% 		nbplans = 3;
	case 'UVL'
		bitclass = 64;
		nbplans = 3;
	case 'UpVpL'
		bitclass = 64;
		nbplans = 3;
	case 'HSV'
		bitclass = [8,16,32,64];
		nbplans = 3;
	case 'YIQ'
		bitclass = [8,16,32,64];
		nbplans = 3;
	case 'YCbCr'
		bitclass = [8,16,64];
		nbplans = 3;
	otherwise
		bitclass = [];
		nbplans = 0;
end

