function val = IsaacHISTO_get(obj,propname)
% @IsaacHISTO : lecture d'une proprit
%
% propname		val
% --------		---
% 'Counts'		obj.counts
% 'CountsRef'	structure = caractristiques de obj.counts
% 'Histo'		obj.histo
% 'HistoRef'	structure = caractristiques de obj.histo
% 'ImaRef'		structure = caractristiques de l'image d'origine
%
%  ATTENTION : val de 'Counts' code en DOUBLE et val de 'Histo' code dans bitclass (1/8/16/32/64) 
%
% OpenIsaac
%  2018 Alain Clment - Universit d'Angers

%---------------------------------------------------------------------------------------------------

% Copyright 2007 - 2018 Universit d'Angers - Author: Alain Clment
%
% This program is free software; you can redistribute it and/or modify it under the terms of the GNU
% General Public License as published by the Free Software Foundation; either version 3 of the
% License, or any later version. This program is distributed in the hope that it will be useful, but
% WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
% PARTICULAR PURPOSE. See the GNU General Public License for more details. You should have received
% a copy of the GNU General Public License along with this program; if not, write to the Free
% Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

%---------------------------------------------------------------------------------------------------

switch propname
	case 'Counts'
		val = obj.counts;
	case 'CountsRef'
		val.effmin	= obj.effmin;
		val.effmax	= obj.effmax;
		val.effsum	= obj.effsum;
	case 'Histo'
		val = obj.histo;
	case 'HistoRef'
		val.bitclass	= obj.bitclass;
		val.plans		= obj.plans;
		val.nb			= obj.valnb;
		val.dim			= obj.valdim;
		val.min			= obj.valmin;
		val.max			= obj.valmax;
		val.sup			= obj.valsup;
	case 'ImaRef'
		val.name		= obj.ima_name;
		val.nbpix	= obj.ima_nbpix;
		val.dimz		= obj.ima_dimz;
		val.nbb		= obj.ima_nbb;
		val.useroi	= obj.ima_useroi;
	otherwise
		error('argument incorrect')
end