function obj = IsaacIMG_changegamma(obj,gamma)
% @IsaacIMG : correction Gamma vectorielle
%				 ROI et espace colorimtrique inchangs
%
% (Appeler en TRY-CATCH pour sortie en erreur d'execution)
%
%	- gamma : valeur de gamma
%
% OpenIsaac
%  2018 Alain Clment - Universit d'Angers

%---------------------------------------------------------------------------------------------------

% Copyright 2007 - 2018 Universit d'Angers - Author: Alain Clment
%
% This program is free software; you can redistribute it and/or modify it under the terms of the GNU
% General Public License as published by the Free Software Foundation; either version 3 of the
% License, or any later version. This program is distributed in the hope that it will be useful, but
% WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
% PARTICULAR PURPOSE. See the GNU General Public License for more details. You should have received
% a copy of the GNU General Public License along with this program; if not, write to the Free
% Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

%---------------------------------------------------------------------------------------------------

global ISAACPREF

if (obj.nbb == 1)
	error('correction gamma impossible')
end	
if (~isscalar(gamma) || (gamma < 0))
	error('argument incorrect')
end
for i = 1:obj.dimz
	obj.img(:,:,i) = imadjust(obj.img(:,:,i),[],[],gamma);
end
if (obj.dimz == 1)
	obj.min = double(min(min(obj.img)));
	obj.max = double(max(max(obj.img)));
else
	obj.min = reshape(double(min(min(obj.img))),1,obj.dimz); % (matrice 1xdimz)
	obj.max = reshape(double(max(max(obj.img))),1,obj.dimz); % (matrice 1xdimz)
end
% recalcul masque de roi valeurs, le masque de roi spatiale reste inchang
if (obj.isroi && ~ISAACPREF.OptimiseImgMem)
	% si ~obj.isroi le masque valeur reste  false de dimension inchange
	obj.roivalmask = IsaacROI_valmask(obj.roi,obj.img);
end
