function obj = IsaacIMG_colorconv(obj,objECOL)
% @IsaacIMG : conversion de l'image dans un nouvel espace colorimtrique
%           ROI ventuellemnt modifie, espace colorimtrique modifi
%
% (Appeler en TRY-CATCH pour sortie en erreur d'execution)
%
%	- objECOL : objet @IsaacECOL
%
% OpenIsaac
%  2018 Alain Clment - Universit d'Angers

%---------------------------------------------------------------------------------------------------

% Copyright 2007 - 2018 Universit d'Angers - Author: Alain Clment
%
% This program is free software; you can redistribute it and/or modify it under the terms of the GNU
% General Public License as published by the Free Software Foundation; either version 3 of the
% License, or any later version. This program is distributed in the hope that it will be useful, but
% WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
% PARTICULAR PURPOSE. See the GNU General Public License for more details. You should have received
% a copy of the GNU General Public License along with this program; if not, write to the Free
% Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

%---------------------------------------------------------------------------------------------------

global ISAACPREF

if ~isa(objECOL,'IsaacECOL')
	error('argument incorrect')
end
if ~obj.iscolorspace
	error('l''image ne possde pas d''espace colorimtrique')
end
olddimz = obj.dimz;
oldnbb = obj.nbb;
oldbitclass = obj.bitclass;
img = IsaacECOL_convert(obj.colorspace,objECOL,IsaacIMG_im2nbb(obj,obj.bitclass),obj.bitclass);
obj = IsaacObjIMGInit(obj,img);
clear img
if (obj.bitclass == oldbitclass)
	% rtablissement du nb de bits
	if ~IsaacBitCheck(obj.img,oldnbb)
		obj.img = IsaacIMG_im2nbb(obj,oldnbb);
		if (obj.dimz == 1)
			obj.min = double(min(min(obj.img)));
			obj.max = double(max(max(obj.img)));
		else
			obj.min = reshape(double(min(min(obj.img))),1,obj.dimz); % (matrice 1xdimz)
			obj.max = reshape(double(max(max(obj.img))),1,obj.dimz); % (matrice 1xdimz)
		end
	end	
	obj.nbb = oldnbb;
	obj.valmax = IsaacValMax(obj.nbb);
end	
ChangeZ = (olddimz ~= obj.dimz);
ChangeB = (oldnbb ~= obj.nbb);
if (ChangeZ || ChangeB)
	% ajustement de roi valeurs
	obj.roi = IsaacROI_adjust(obj.roi,'RoiVal',obj.dimz,obj.nbb);
	if ChangeZ
		IsaacMessageWarning('nombre de plans de l''image modifi')
	end
	if ChangeB
		IsaacMessageWarning('nombre de bits de l''image modifi')
	end
end	
% recalcul masque de roi valeurs
if (obj.isroi && ~ISAACPREF.OptimiseImgMem)
	% si ~obj.isroi le masque valeur reste  false de dimension inchange
	obj.roivalmask = IsaacROI_valmask(obj.roi,obj.img);
end
% modification espace colorimtrique
obj.colorspace = objECOL;
