function mat = IsaacIMG_img2mat(obj,varargin)
% @IsaacIMG : retourne la matrice image de obj
%
%	mat = IsaacIMG_img2mat(obj) 
%		=> matrice image nbbits inchangs
%
%	mat = IsaacIMG_img2mat(obj,'BitClass') 
%		=> matrice image convertie en type Matlab
%		   (1/2...8/9...16/32/64 -> logical/uint8/uint16/single/double)
%
%	mat = IsaacIMG_img2mat(obj, <type>) 
%		=> matrice image convertie en type = 'logical'|'uint8'|'uint16'|'single'|'double'
%
% OpenIsaac
%  2018 Alain Clment - Universit d'Angers

%---------------------------------------------------------------------------------------------------

% Copyright 2007 - 2018 Universit d'Angers - Author: Alain Clment
%
% This program is free software; you can redistribute it and/or modify it under the terms of the GNU
% General Public License as published by the Free Software Foundation; either version 3 of the
% License, or any later version. This program is distributed in the hope that it will be useful, but
% WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
% PARTICULAR PURPOSE. See the GNU General Public License for more details. You should have received
% a copy of the GNU General Public License along with this program; if not, write to the Free
% Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

%---------------------------------------------------------------------------------------------------

switch nargin
case 1
	mat = obj.img;
case 2	
	switch varargin{1}
	case 'BitClass'
		mat = IsaacIMG_im2nbb(obj,obj.bitclass);
	case 'logical'
		mat = IsaacIMG_im2nbb(obj,1);
	case 'uint8'
		mat = IsaacIMG_im2nbb(obj,8);
	case 'uint16'
		mat = IsaacIMG_im2nbb(obj,16);
	case 'single'
		mat = IsaacIMG_im2nbb(obj,32);
	case 'double'
		mat = IsaacIMG_im2nbb(obj,64);
	otherwise
		error('argument incorrect')
	end
otherwise
	error('nombre d''arguments incorrect')
end
	