function ok = IsaacBitCheck(img,nbbits)
% Vrifie la compatibilit du nombre de bits avec la matrice image
%
% - img		 : matrice image
% - nbbits	 : nombre de bits (1  16/32/64)
%
% OpenIsaac
%  2018 Alain Clment - Universit d'Angers

%---------------------------------------------------------------------------------------------------

% Copyright 2007 - 2018 Universit d'Angers - Author: Alain Clment
%
% This program is free software; you can redistribute it and/or modify it under the terms of the GNU
% General Public License as published by the Free Software Foundation; either version 3 of the
% License, or any later version. This program is distributed in the hope that it will be useful, but
% WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
% PARTICULAR PURPOSE. See the GNU General Public License for more details. You should have received
% a copy of the GNU General Public License along with this program; if not, write to the Free
% Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

%---------------------------------------------------------------------------------------------------

if isa(img,'logical')
	ok = (nbbits == 1);
elseif isa(img,'uint8')
	imax = max(max(max(img))); % pour nb plans >= 1
	ok = (ismember(nbbits,2:8) && (imax <= 2^nbbits - 1));
elseif isa(img,'uint16')
	imax = max(max(max(img))); % pour nb plans >= 1
	ok = (ismember(nbbits,9:16) && (imax <= 2^nbbits - 1));
elseif isa(img,'single')
	ok = (nbbits == 32);
elseif isa(img,'double')
	ok = (nbbits == 64);
else
	ok = false;
end