function objstruct = IsaacObjIMGInit(objstruct,img)
% Initialise objstruct avec une nouvelle matrice image
%
% OpenIsaac
%  2018 Alain Clment - Universit d'Angers

%---------------------------------------------------------------------------------------------------

% Copyright 2007 - 2018 Universit d'Angers - Author: Alain Clment
%
% This program is free software; you can redistribute it and/or modify it under the terms of the GNU
% General Public License as published by the Free Software Foundation; either version 3 of the
% License, or any later version. This program is distributed in the hope that it will be useful, but
% WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
% PARTICULAR PURPOSE. See the GNU General Public License for more details. You should have received
% a copy of the GNU General Public License along with this program; if not, write to the Free
% Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

%---------------------------------------------------------------------------------------------------

global ISAACPREF

[objstruct.bitclass,objstruct.dimz] = IsaacImgType(img);
if (~objstruct.bitclass || ~objstruct.dimz)
	error('type d''image inconnu ou non gr')
end
objstruct.nbb = objstruct.bitclass;
objstruct.valmax = IsaacValMax(objstruct.nbb);
objstruct.dimy = size(img,1);
objstruct.dimx = size(img,2);
% taille mini 2x2xdimz pour faciliter les calculs (1x1 => cas particuliers)
if ((objstruct.dimx < 2) || (objstruct.dimy < 2))
	error('les dimensions de l''image sont incorrectes')
end
if (objstruct.dimz > ISAACPREF.ImMaxPlans)
	error('le nombre de plans dpasse la limite fixe en prfrences')
end	
if (objstruct.dimz == 1)
	objstruct.min = double(min(min(img)));
	objstruct.max = double(max(max(img)));
else
	objstruct.min = reshape(double(min(min(img))),1,objstruct.dimz); % (matrice 1xdimz)
	objstruct.max = reshape(double(max(max(img))),1,objstruct.dimz); % (matrice 1xdimz)
end
objstruct.img = img;