function IsaacImage_cible(obj,auteur)
% @IsaacImage : l'image devient la cible si elle ne l'est pas dj
%
% - auteur : handle figure (outil ou image) qui a provoqu l'vnement
%
% @-> EVENEMENT 2
%
% OpenIsaac
%  2018 Alain Clment - Universit d'Angers

%---------------------------------------------------------------------------------------------------

% Copyright 2007 - 2018 Universit d'Angers - Author: Alain Clment
%
% This program is free software; you can redistribute it and/or modify it under the terms of the GNU
% General Public License as published by the Free Software Foundation; either version 3 of the
% License, or any later version. This program is distributed in the hope that it will be useful, but
% WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
% PARTICULAR PURPOSE. See the GNU General Public License for more details. You should have received
% a copy of the GNU General Public License along with this program; if not, write to the Free
% Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

%---------------------------------------------------------------------------------------------------

global ISAACPRIV
global ISAACPREF

if (obj ~= ISAACPRIV.Cible)
	oldcible = ISAACPRIV.Cible;
	if ~isempty(oldcible)
		% dsactivation de la marque image de l'ancienne cible
		set(findobj(oldcible.fighnd,'Tag','ButSelect'),'BackgroundColor',ISAACPREF.IsaacColor1)
		% dsactivation ventuelle du zoom
		zoom(oldcible.fighnd,'off')
	end
	ISAACPRIV.Cible = obj;
	% activation de la marque image de la nouvelle cible
	if (obj.status == 1)
		set(findobj(obj.fighnd,'Tag','ButSelect'),'BackgroundColor',ISAACPREF.CibleColor1)
	else
		set(findobj(obj.fighnd,'Tag','ButSelect'),'BackgroundColor',ISAACPREF.CibleColor2)
	end
	% mise au premier plan
	figure(obj.fighnd)
	% ractivation ventuelle du zoom
	if obj.zoom
		zoom(obj.fighnd,'on')
	end
	% EVENEMENT
	IsaacImage_event(obj,auteur,2)
end