function obj = IsaacLPIX_adjust(obj,objIMG)
% @IsaacLPIX : ajuste obj  une nouvelle image en supprimant les pixels et les plans hors image 
%					et en recalculant les valeurs
%
%	- objIMG	: objet @IsaacIMG
%
% OpenIsaac
%  2018 Alain Clment - Universit d'Angers

%---------------------------------------------------------------------------------------------------

% Copyright 2007 - 2018 Universit d'Angers - Author: Alain Clment
%
% This program is free software; you can redistribute it and/or modify it under the terms of the GNU
% General Public License as published by the Free Software Foundation; either version 3 of the
% License, or any later version. This program is distributed in the hope that it will be useful, but
% WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
% PARTICULAR PURPOSE. See the GNU General Public License for more details. You should have received
% a copy of the GNU General Public License along with this program; if not, write to the Free
% Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

%---------------------------------------------------------------------------------------------------

if ~isa(objIMG,'IsaacIMG')
	error('argument incorrect')
end
% Ajustement spatial et maj image de rfrence
if obj.nbpix
	dimx = IsaacIMG_get(objIMG,'DimX');
	dimy = IsaacIMG_get(objIMG,'DimY');
	if (dimx < obj.ima_dimx)
		obj.pix_mat(obj.pix_mat(:,1) > dimx,:) = [];
		obj.ima_dimx = dimx;
	end	
	if (dimy < obj.ima_dimy)
		obj.pix_mat(obj.pix_mat(:,2) > dimy,:) = [];
		obj.ima_dimy = dimy;
	end	
	obj.nbpix = size(obj.pix_mat,1);
end
% Recalcul des valeurs
if obj.nbpix
	dimz = IsaacIMG_get(objIMG,'DimZ');
	% ajustement ventuel des dimensions et maj image de rfrence
	if (obj.ima_dimz > dimz)
		obj.pix_mat(:,dimz+3:end) = [];
	elseif (obj.ima_dimz < dimz)
		obj.pix_mat(:,obj.ima_dimz+3:dimz+2) = zeros(obj.nbpix,dimz - obj.ima_dimz);
	end	
	obj.ima_dimz = dimz;
	% recalcul de la liste et maj image de rfrence
	img = IsaacIMG_get(objIMG,'Img');
	newval = obj.pix_mat(:,3:end);
	for i = 1:obj.nbpix
		for j = 1:dimz
			newval(i,j) = double(img(obj.pix_mat(i,2),obj.pix_mat(i,1),j));
		end
	end	
	% conversion ventuelle 64 bits
	valmax = IsaacIMG_get(objIMG,'ValMax');
	if (valmax ~= 1)
		newval = newval/valmax;
	end
	obj.pix_mat(:,3:end) = newval;
end