function val = IsaacROI_get(obj,propname)
% @IsaacROI : lecture d'une proprit
%
% propname		val
% --------		---
% 'ImaRef'		structure = caractristiques de l'image de rfrence
% 'IsRoi'		obj.isspa || any(obj.isval)
% 'IsRoiSpa'	obj.isspa
% 'IsRoiVal'	obj.isval
% 'RoiSpa'		obj.spa_mat
% 'RoiSpaIn'	obj.spa_in
% 'RoiSpaNb'	obj.spa_nb
% 'RoiVal'		obj.val_mat
% 'RoiValIn'	obj.val_in
% 'RoiValMax'	obj.valmax
% 'RoiValNb'	obj.val_nb
%
%	ATTENTION : val de 'RoiSpa' et 'RoiVal' codes en DOUBLE
%
% OpenIsaac
%  2018 Alain Clment - Universit d'Angers

%---------------------------------------------------------------------------------------------------

% Copyright 2007 - 2018 Universit d'Angers - Author: Alain Clment
%
% This program is free software; you can redistribute it and/or modify it under the terms of the GNU
% General Public License as published by the Free Software Foundation; either version 3 of the
% License, or any later version. This program is distributed in the hope that it will be useful, but
% WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
% PARTICULAR PURPOSE. See the GNU General Public License for more details. You should have received
% a copy of the GNU General Public License along with this program; if not, write to the Free
% Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

%---------------------------------------------------------------------------------------------------

switch propname
	case 'ImaRef'
		val.dimx	= obj.ima_dimx;
		val.dimy	= obj.ima_dimy;
		val.dimz	= obj.ima_dimz;
		val.nbb	= obj.ima_nbb;
	case 'IsRoi'
		val = obj.isspa || any(obj.isval);
	case 'IsRoiSpa'
		val = obj.isspa;
	case 'IsRoiVal'
		val = obj.isval;
	case 'RoiSpa'
		val = obj.spa_mat;
	case 'RoiSpaIn'
		val = obj.spa_in;
	case 'RoiSpaNb'
		val = obj.spa_nb;
	case 'RoiVal'
		val = obj.val_mat;
	case 'RoiValIn'
		val = obj.val_in;
	case 'RoiValMax'
		val = obj.valmax;
	case 'RoiValNb'
		val = obj.val_nb;
	otherwise
		error('argument incorrect')
end