function obj = IsaacROI_reorder(obj,plans)
% @IsaacROI : rordonne les plans dans l'ordre de la matrice plans
%
%	- plans  : matrice(1,ima_dimz) des numros de plans => impose l'ordre des plans
%
% OpenIsaac
%  2018 Alain Clment - Universit d'Angers

%---------------------------------------------------------------------------------------------------

% Copyright 2007 - 2018 Universit d'Angers - Author: Alain Clment
%
% This program is free software; you can redistribute it and/or modify it under the terms of the GNU
% General Public License as published by the Free Software Foundation; either version 3 of the
% License, or any later version. This program is distributed in the hope that it will be useful, but
% WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
% PARTICULAR PURPOSE. See the GNU General Public License for more details. You should have received
% a copy of the GNU General Public License along with this program; if not, write to the Free
% Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

%---------------------------------------------------------------------------------------------------

if (~isequal(size(plans),[1 obj.ima_dimz]) || any(plans < 1) || any(plans > obj.ima_dimz) || ...
	(length(unique(plans)) ~= length(plans))) % erreur si doublons
	error('argument incorrect')
end
isval = obj.isval;
for i = 1:obj.ima_dimz
	obj.isval(i) = isval(plans(i));
end
if obj.val_nb
	valmat = obj.val_mat;
	for i = 1:obj.ima_dimz
		obj.val_mat(:,2*i-1:2*i) = valmat(:,2*plans(i)-1:2*plans(i));
	end
end	

