function obj = IsaacROI_resize(obj,dimx,dimy)
% @IsaacROI : modifie la taille de l'image de rfrence en ajustant la roi spatiale
%				  avec suppression des doublons
%
%	- dimx,dimy : nouvelles dimensions image de rfrence 
%
% OpenIsaac
%  2018 Alain Clment - Universit d'Angers

%---------------------------------------------------------------------------------------------------

% Copyright 2007 - 2018 Universit d'Angers - Author: Alain Clment
%
% This program is free software; you can redistribute it and/or modify it under the terms of the GNU
% General Public License as published by the Free Software Foundation; either version 3 of the
% License, or any later version. This program is distributed in the hope that it will be useful, but
% WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
% PARTICULAR PURPOSE. See the GNU General Public License for more details. You should have received
% a copy of the GNU General Public License along with this program; if not, write to the Free
% Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

%---------------------------------------------------------------------------------------------------

if ((dimx < 2) || (dimy < 2))
	error('argument incorrect')
end
if obj.spa_nb
	obj.spa_mat(:,1:2) = round(obj.spa_mat(:,1:2)*dimx/obj.ima_dimx);
	obj.spa_mat(:,3:4) = round(obj.spa_mat(:,3:4)*dimy/obj.ima_dimy);
	obj.spa_mat(obj.spa_mat < 1) = 1;
	obj.spa_mat(obj.spa_mat(:,1) > dimx,1) = dimx;
	obj.spa_mat(obj.spa_mat(:,2) > dimx,2) = dimx;
	obj.spa_mat(obj.spa_mat(:,3) > dimy,3) = dimy;
	obj.spa_mat(obj.spa_mat(:,4) > dimy,4) = dimy;
	% Suppression des doublons ventuels
	obj = IsaacROI_optimise(obj);
end	
obj.ima_dimx = dimx;
obj.ima_dimy = dimy;
