function param = IsaacParamImport(paramtype,varname)
% Importe un paramtre de MATLAB base workspace
%
% (Appeler en TRY-CATCH pour sortie en erreur d'execution) 
%
% OpenIsaac
%  2018 Alain Clment - Universit d'Angers

%---------------------------------------------------------------------------------------------------

% Copyright 2007 - 2018 Universit d'Angers - Author: Alain Clment
%
% This program is free software; you can redistribute it and/or modify it under the terms of the GNU
% General Public License as published by the Free Software Foundation; either version 3 of the
% License, or any later version. This program is distributed in the hope that it will be useful, but
% WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
% PARTICULAR PURPOSE. See the GNU General Public License for more details. You should have received
% a copy of the GNU General Public License along with this program; if not, write to the Free
% Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

%---------------------------------------------------------------------------------------------------

if (size(varname,1) ~= 1) || ~isa(varname,'char')
	error('argument incorrect')
end		
if evalin('base',['~exist(''',varname,''',''var'')'])
	error('variable inexistante')
end	
param = evalin('base',varname);

switch paramtype
	case 'Image'
		ok = isa(param,'IsaacImage'); 
	case 'IMG'
		ok = isa(param,'IsaacIMG'); 
	case 'ROI'
		ok = isa(param,'IsaacROI');	
	case 'ECOL'
		ok = isa(param,'IsaacECOL');	
	case 'HISTO'
		ok = isa(param,'IsaacHISTO');
	case 'LPIX'
		ok = isa(param,'IsaacLPIX');	
	case 'DATA'
		ok = isa(param,'IsaacDATA');
	otherwise
		ok = false;
end		
if ~ok
	error('variable incompatible');
end	
