function IsaacParamPush(param)
% Ecrit un paramtre en mmoire
%
% OpenIsaac
%  2018 Alain Clment - Universit d'Angers

%---------------------------------------------------------------------------------------------------

% Copyright 2007 - 2018 Universit d'Angers - Author: Alain Clment
%
% This program is free software; you can redistribute it and/or modify it under the terms of the GNU
% General Public License as published by the Free Software Foundation; either version 3 of the
% License, or any later version. This program is distributed in the hope that it will be useful, but
% WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
% PARTICULAR PURPOSE. See the GNU General Public License for more details. You should have received
% a copy of the GNU General Public License along with this program; if not, write to the Free
% Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

%---------------------------------------------------------------------------------------------------

global ISAACPRIV

switch class(param)
	case 'IsaacDATA'
		% donne (objet @IsaacDATA)
		ISAACPRIV.ParamMem.DATA = param;
	case 'IsaacECOL'
		% espace colorimrique (objet @IsaacECOL)
		ISAACPRIV.ParamMem.ECOL = param;
	case 'IsaacHISTO'
		% histogramme (objet @IsaacHISTO)
		ISAACPRIV.ParamMem.HISTO = param;
	case 'IsaacIMG'
		% image (objet @IsaacIMG)
		ISAACPRIV.ParamMem.IMG = param;
	case 'IsaacLPIX'
		% liste de pixels (objet @IsaacLPIX optimis)
		ISAACPRIV.ParamMem.LPIX = IsaacLPIX_optimise(param);
	case 'IsaacROI'
		% rgion d'intrt (objet @IsaacROI optimis)
		ISAACPRIV.ParamMem.ROI = IsaacROI_optimise(param);
	otherwise
		error('paramtre inconnu')
end
