function DataEdit()
% Editeur de @IsaacDATA
%
% Tool for OpenIsaac
%  2018 Alain Clment - Universit d'Angers

%---------------------------------------------------------------------------------------------------

% Copyright 2007 - 2018 Universit d'Angers - Author: Alain Clment
%
% This program is free software; you can redistribute it and/or modify it under the terms of the GNU
% General Public License as published by the Free Software Foundation; either version 3 of the
% License, or any later version. This program is distributed in the hope that it will be useful, but
% WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
% PARTICULAR PURPOSE. See the GNU General Public License for more details. You should have received
% a copy of the GNU General Public License along with this program; if not, write to the Free
% Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

%---------------------------------------------------------------------------------------------------

% structure ud : champ UserData
%	ToolDir		: rpertoire de l'outil
%	PTarget		: 1 = workspace, 2 = mmoire, 3 = fichier, 4  = MATLAB base workspace
%	Param       : objet @IsaacDATA dit
%	PVarName    : nom de la variable associe au paramtre dit (objet @IsaacDATA)
%	WSVarName	: nom de la variable cible (valeur de l'objet)

%---------------------------------------------------------------------------------------------------

global ISAACINFO

% si DataEdit est dja lanc, l'ammener au premier plan.
h = findobj(allchild(0),'flat','Tag','DataEdit');
if ~isempty(h)
	figure(h(1)) % mise au 1er plan
   return
end

hauteurfig = 280;
% figure(position selon ISAACINFO.DefPos)
h0 = figure( ...
	'CloseRequestFcn','DataEdit_cb CloseBox', ...
	'Name','DataEdit', ...
	'Position',IsaacFenPos(ISAACINFO.DefPos(1),ISAACINFO.DefPos(2),285,hauteurfig,0), ...
	'Tag','DataEdit');

IsaacDefaultProperties(h0)

% text Type
uicontrol('Parent',h0, ...
	'Enable','inactive', ...
	'ForegroundColor',ISAACINFO.TextColor2, ...
	'HorizontalAlignment','left', ...
	'Position',[5 hauteurfig - 20 35 15], ...
	'String','Type :', ...
	'Style','text');
% popup Type
uicontrol('Parent',h0, ...
	'Callback','DataEdit_cb PopupType', ...
	'Position',[45 hauteurfig - 20 80 16], ...
	'Style','popupmenu', ...
	'Tag','PopupType');
% text DataClass
uicontrol('Parent',h0, ...
	'Enable','inactive', ...
	'ForegroundColor',ISAACINFO.TextColor2, ...
	'HorizontalAlignment','left', ...
	'Position',[130 hauteurfig - 20 40 15], ...
	'String','Classe :', ...
	'Style','text');
% text DataClass val
uicontrol('Parent',h0, ...
	'BackgroundColor',ISAACINFO.IsaacColor2, ...
	'Enable','inactive', ...
	'FontSize',ISAACINFO.FontSize + 1, ...
	'Position',[175 hauteurfig - 20 105 15], ...
	'Style','text', ...
	'Tag','StxtDataClassVal');
% liste Valeur 
uicontrol('Parent',h0, ...
	'BackgroundColor',ISAACINFO.IsaacColor2, ...
	'Enable','inactive', ...
	'FontName','Monospaced', ...
	'FontSize',ISAACINFO.FontSize + 1, ...
	'SelectionHighlight','off', ...
	'Position',[5 hauteurfig - 124 200 95], ...
	'Style','listbox', ...
	'Tag','ListVal', ...
	'Value',1);
% bouton LVaddfic
uicontrol('Parent',h0, ...
	'BackgroundColor',ISAACINFO.IsaacColor3, ...
	'Callback','DataEdit_cb ButLVaddfic', ...
	'Position',[210 hauteurfig - 53 70 20], ...
	'String','NFIC', ...
	'Tag','ButLVaddfic');
% bouton LVaddrep
uicontrol('Parent',h0, ...
	'BackgroundColor',ISAACINFO.IsaacColor3, ...
	'Callback','DataEdit_cb ButLVaddrep', ...
	'Position',[210 hauteurfig - 77 70 20], ...
	'String','NREP', ...
	'Tag','ButLVaddrep');
% bouton LVaddficliste
uicontrol('Parent',h0, ...
	'BackgroundColor',ISAACINFO.IsaacColor3, ...
	'Callback','DataEdit_cb ButLVaddficliste', ...
	'Position',[210 hauteurfig - 101 70 20], ...
	'String','LFIC', ...
	'Tag','ButLVaddficliste');
% checkbox Recursif	
uicontrol('Parent',h0, ...
	'Position',[210 hauteurfig - 125 70 18], ...
	'String','Rcursif', ...
	'Style','checkbox', ...
	'Value',0, ...
	'Tag', 'ChkRecursif');
% text Info
uicontrol('Parent',h0, ...
	'Enable','inactive', ...
	'ForegroundColor',ISAACINFO.TextColor2, ...
	'HorizontalAlignment','left', ...
	'Position',[5 hauteurfig - 155 40 15], ...
	'String','Info :', ...
	'Style','text');
% edit Info val
uicontrol('Parent',h0, ...
	'BackgroundColor',ISAACINFO.IsaacColor2, ...
	'Callback','DataEdit_cb EtxtInfoVal', ...
	'FontSize',ISAACINFO.FontSize, ...
	'Position',[50 hauteurfig - 157 230 24], ...
	'Style','edit', ...
	'Tag','EtxtInfoVal');
% Sparateur
uicontrol('Parent',h0, ...
	'BackgroundColor',ISAACINFO.TextColor1, ...
	'Enable','inactive', ...
	'Position',[0 hauteurfig - 165 285 1], ...
	'Style','frame');
% text TargetInfo  ---------------------------------------------------------------------------------	
uicontrol('Parent',h0, ...
	'BackgroundColor',ISAACINFO.IsaacColor2, ...
	'Enable','inactive', ...
	'FontSize',ISAACINFO.FontSize + 1, ...
	'Position',[5 hauteurfig - 185 275 15], ...
	'Style','text', ...
	'Tag','StxtTargetInfo');
% Bouton radio Param workspace
uicontrol('Parent',h0, ...
	'Callback','DataEdit_cb RadButParamWS', ...
	'String','Base Workspace', ...
	'Style','radiobutton', ...
	'Position',[5 hauteurfig - 210 130 15], ...
	'Tag','RadButParamWS');
% edit WSVarname	
uicontrol('Parent',h0, ...
	'BackgroundColor',ISAACINFO.IsaacColor2, ...
	'Callback','DataEdit_cb EtxtWSVarname', ...
	'FontSize',ISAACINFO.FontSize, ...
	'Position',[135 hauteurfig - 214 145 22], ...
	'Style','edit', ...
	'Tag','EtxtWSVarname');
% Bouton radio Param mmoire
uicontrol('Parent',h0, ...
	'Callback','DataEdit_cb RadButParamMem', ...
	'String','Mmoire', ...
	'Style','radiobutton', ...
	'Position',[5 hauteurfig - 230 100 15], ...
	'Tag','RadButParamMem');
% Bouton radio Param fichier
uicontrol('Parent',h0, ...
	'Callback','DataEdit_cb RadButParamFich', ...
	'String','Fichier', ...
	'Style','radiobutton', ...
	'Position',[5 hauteurfig - 250 100 15], ...
	'Tag','RadButParamFich');
% Bouton radio Param MATLAB
uicontrol('Parent',h0, ...
	'Callback','DataEdit_cb RadButParamMATLAB', ...
	'String','MATLAB', ...
	'Style','radiobutton', ...
	'Position',[5 hauteurfig - 270 100 15], ...
	'Tag','RadButParamMATLAB');
% edit Varname	
uicontrol('Parent',h0, ...
	'BackgroundColor',ISAACINFO.IsaacColor2, ...
	'Callback','DataEdit_cb EtxtVarname', ...
	'FontSize',ISAACINFO.FontSize, ...
	'Position',[85 hauteurfig - 274 80 22], ...
	'Style','edit', ...
	'Tag','EtxtVarname');
% bouton ParamPull
uicontrol('Parent',h0, ...
	'BackgroundColor',ISAACINFO.IsaacColor3, ...
	'Callback','DataEdit_cb ButParamPull', ...
	'Position',[190 hauteurfig - 250 90 20], ...
	'String','Importer', ...
	'Tag','ButParamPull');
% bouton ParamPush
uicontrol('Parent',h0, ...
	'BackgroundColor',ISAACINFO.IsaacColor3, ...
	'Callback','DataEdit_cb ButParamPush', ...
	'Position',[190 hauteurfig - 275 90 20], ...
	'String','Exporter', ...
	'Tag','ButParamPush');

%---------------------------------------------------------------------------------------------------

% Initialisation

ud.ToolDir = fileparts(mfilename('fullpath'));
ud.Param = IsaacDATA('VALX',[],''); 
ud.PVarName = 'x';
ud.WSVarName = 'v';
ud.PTarget = 1; % workspace
set(h0,'UserData',ud);
set(findobj(h0,'Tag','RadButParamWS'),'Value',1)
set(findobj(h0,'Tag','EtxtWSVarname'),'String',ud.WSVarName)
set(findobj(h0,'Tag','EtxtVarname'),'String',ud.PVarName)
DataEdit_maj(h0,'Popup','Valeurs');
addpath(ud.ToolDir)
