function ImageVue_cb(choix)
% Callback ImageVue
%
% Tool for OpenIsaac
%  2018 Alain Clment - Universit d'Angers

%---------------------------------------------------------------------------------------------------

% Copyright 2007 - 2018 Universit d'Angers - Author: Alain Clment
%
% This program is free software; you can redistribute it and/or modify it under the terms of the GNU
% General Public License as published by the Free Software Foundation; either version 3 of the
% License, or any later version. This program is distributed in the hope that it will be useful, but
% WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
% PARTICULAR PURPOSE. See the GNU General Public License for more details. You should have received
% a copy of the GNU General Public License along with this program; if not, write to the Free
% Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

%---------------------------------------------------------------------------------------------------

% Utilise la rception d'vnements causs par (auteur = soi-mme) pour mise  jour graphique

%---------------------------------------------------------------------------------------------------

global ISAACINFO

cible = IsaacImageCible;

switch(choix)
case 'CloseBox'
	ud = get(gcbf,'UserData');
	if ~ISAACINFO.IsEnd
		IsaacEventUpdListe(gcbf,[])
	end
	rmpath(ud.ToolDir)
	closereq
case 'PopupPlan1'
	parama = IsaacImage_get(cible,'ParamA');
	parama.plan(1) = get(gcbo,'Value');
	IsaacImage_set(cible,gcbf,'ParamA',parama);
	% maj graphique par ImageVue_upd
case 'PopupPlan2'
	parama = IsaacImage_get(cible,'ParamA');
	parama.plan(2) = get(gcbo,'Value');
	IsaacImage_set(cible,gcbf,'ParamA',parama);
	% maj graphique par ImageVue_upd
case 'PopupPlan3'
	parama = IsaacImage_get(cible,'ParamA');
	parama.plan(3) = get(gcbo,'Value');
	IsaacImage_set(cible,gcbf,'ParamA',parama);
	% maj graphique par ImageVue_upd
case 'RadMarginal'
	v = get(gcbo,'Value');
	if v == 1 % tait  0 et vient d'tre mis  1
		parama = IsaacImage_get(cible,'ParamA');
		parama.plan(1) = get(findobj(gcbf,'Tag','PopupPlan1'),'Value');
		parama.marginal = true;
		IsaacImage_set(cible,gcbf,'ParamA',parama);
		% maj graphique par ImageVue_upd
	else % tait  1 et vient d'tre mis  0
		set(gcbo,'Value',1)	
	end	
case 'RadCouleur'
	v = get(gcbo,'Value');
	if v == 1 % tait  0 et vient d'tre mis  1
		val1 = get(findobj(gcbf,'Tag','PopupPlan1'),'Value');
		val2 = get(findobj(gcbf,'Tag','PopupPlan2'),'Value');
		val3 = get(findobj(gcbf,'Tag','PopupPlan3'),'Value');
		parama = IsaacImage_get(cible,'ParamA');
		parama.plan = [val1,val2,val3];
		parama.marginal = false;
		IsaacImage_set(cible,gcbf,'ParamA',parama);
		% maj graphique par ImageVue_upd
	else % tait  1 et vient d'tre mis  0
		set(gcbo,'Value',1)	
	end	
case 'ButEch-'
	echelle = IsaacImage_get(cible,'Echelle');
	if (echelle <= 1)
		t = round(1/echelle);
		essai = 1/(t + 1);
	else
		essai = echelle - 1;
	end
	IsaacImage_set(cible,gcbf,'Echelle',essai); % chelle souhaite
	% maj graphique par ImageVue_upd avec chelle effective
	echelle = IsaacImage_get(cible,'Echelle'); % chelle effective
	if (echelle ~= essai)
		% rduction d'chelle impossible : l'chelle reste inchange
		IsaacSound('Buzz')
		set(gcbo,'Enable','off')
	end
case 'ButEchR'
	IsaacImage_set(cible,gcbf,'Echelle',1); % chelle souhaite
	% maj graphique par ImageVue_upd avec chelle effective
	set(findobj(gcbf,'Tag','ButEch-'),'Enable','on')
	set(findobj(gcbf,'Tag','ButEch+'),'Enable','on')
case 'ButEch+'
	echelle = IsaacImage_get(cible,'Echelle');
	if (echelle < 1) 
		t = round(1/echelle);
		essai = 1/(t - 1);
	else
		essai = echelle + 1;
	end
	IsaacImage_set(cible,gcbf,'Echelle',essai); % chelle souhaite
	% maj graphique par ImageVue_upd avec chelle effective
	echelle = IsaacImage_get(cible,'Echelle'); % chelle effective
	if (echelle ~= essai)
		% augmentation d'chelle impossible : l'chelle reste inchange 
		IsaacSound('Buzz')
		set(gcbo,'Enable','off')
	end
case 'ChkZoom'
	v = get(gcbo,'Value');
	if v
		IsaacImage_set(cible,gcbf,'Zoom','on');
	else
		IsaacImage_set(cible,gcbf,'Zoom','off');
	end
	% maj graphique par ImageVue_upd
case 'ButZoomReset'
	IsaacImage_set(cible,gcbf,'Zoom','out');
	% maj graphique par ImageVue_upd
case 'ButGamma-'
	% pb d'arrondi: a = 1, a = a-0.1 10 fois ne donne pas 0 pile !!!!
	val = IsaacImage_get(cible,'ParamA');
	g = round(10*val.gamma);
	if (g == 1)
		IsaacSound('Buzz')
		set(gcbo,'Enable','off')
	else
		if g > 10
			g = g - 5; 
		else	
			g = g - 1;
		end	
		val.gamma = g/10;
		IsaacImage_set(cible,gcbf,'ParamA',val);
		% maj graphique par ImageVue_upd
	end	
case 'ButGammaR'
	val = IsaacImage_get(cible,'ParamA');
	val.gamma = 1;
	IsaacImage_set(cible,gcbf,'ParamA',val);
	% maj graphique par ImageVue_upd
case 'ButGamma+'
	% pb d'arrondi: a = 1, a = a-0.1 10 fois ne donne pas 0 pile !!!!
	val = IsaacImage_get(cible,'ParamA');
	g = round(10*val.gamma);
	if (g == 100)
		IsaacSound('Buzz')
		set(gcbo,'Enable','off')
	else
		if g >= 10
			g = g + 5; 
		else	
			g = g + 1;
		end	
		val.gamma = g/10;
		IsaacImage_set(cible,gcbf,'ParamA',val);
		% maj graphique par ImageVue_upd
	end
case 'ChkED'
	val = IsaacImage_get(cible,'ParamA');
	val.ED = logical(get(gcbo,'Value'));
	IsaacImage_set(cible,gcbf,'ParamA',val);
	% maj graphique par ImageVue_upd
case 'PopupPal'
	val = IsaacImage_get(cible,'ParamA');
	val.pal = get(gcbo,'Value');
	IsaacImage_set(cible,gcbf,'ParamA',val);
	% maj graphique par ImageVue_upd
case 'ROIS0'
	v = get(gcbo,'Value');
	if v == 1 % tait  0 et vient d'tre mis  1
		val = IsaacImage_get(cible,'ParamARoi');
		val.showRoiSpa = 0;
		IsaacImage_set(cible,gcbf,'ParamARoi',val);
		% maj graphique par ImageVue_upd
	else % tait  1 et vient d'tre mis  0
		set(gcbo,'Value',1)	
	end	
case 'ROISR'
	v = get(gcbo,'Value');
	if v == 1 % tait  0 et vient d'tre mis  1
		val = IsaacImage_get(cible,'ParamARoi');
		val.showRoiSpa = 1;
		IsaacImage_set(cible,gcbf,'ParamARoi',val);
		% maj graphique par ImageVue_upd
	else % tait  1 et vient d'tre mis  0
		set(gcbo,'Value',1)	
	end	
case 'ROISC'
	v = get(gcbo,'Value');
	if v == 1 % tait  0 et vient d'tre mis  1
		val = IsaacImage_get(cible,'ParamARoi');
		val.showRoiSpa = 2;
		IsaacImage_set(cible,gcbf,'ParamARoi',val);
		% maj graphique par ImageVue_upd
	else % tait  1 et vient d'tre mis  0
		set(gcbo,'Value',1)	
	end	
case 'ROIV0'
	v = get(gcbo,'Value');
	if v == 1 % tait  0 et vient d'tre mis  1
		val = IsaacImage_get(cible,'ParamARoi');
		val.showRoiVal = 0;
		IsaacImage_set(cible,gcbf,'ParamARoi',val);
		% maj graphique par ImageVue_upd
	else % tait  1 et vient d'tre mis  0
		set(gcbo,'Value',1)	
	end	
case 'ROIVR'
	v = get(gcbo,'Value');
	if v == 1 % tait  0 et vient d'tre mis  1
		val = IsaacImage_get(cible,'ParamARoi');
		val.showRoiVal = 1;
		IsaacImage_set(cible,gcbf,'ParamARoi',val);
		% maj graphique par ImageVue_upd
	else % tait  1 et vient d'tre mis  0
		set(gcbo,'Value',1)	
	end	
case 'ROIVC'
	v = get(gcbo,'Value');
	if v == 1 % tait  0 et vient d'tre mis  1
		val = IsaacImage_get(cible,'ParamARoi');
		val.showRoiVal = 2;
		IsaacImage_set(cible,gcbf,'ParamARoi',val);
		% maj graphique par ImageVue_upd
	else % tait  1 et vient d'tre mis  0
		set(gcbo,'Value',1)	
	end	
case 'ROIcomp'
	val = IsaacImage_get(cible,'ParamARoi');
	val.showRoiComp = logical(get(gcbo,'Value'));
	IsaacImage_set(cible,gcbf,'ParamARoi',val);
	% maj graphique par ImageVue_upd
case 'ButCreerVisuel'
	try
		IsaacImage(gcbf,IsaacImage_get(cible,'ImgA'),[IsaacImage_get(cible,'Name'),'-v'], ...
			[],IsaacECOL('SRGB','D65'));
	catch exception
		IsaacMessageErreur(IsaacError(exception))
	end
end	
