function IsaacMenuBar()
% Barre de menu Isaac
% remplit le tableau des modules ISAACPRIV.TabMod[]
%
% OpenIsaac
%  2018 Alain Clment - Universit d'Angers

%---------------------------------------------------------------------------------------------------

% Copyright 2007 - 2018 Universit d'Angers - Author: Alain Clment
%
% This program is free software; you can redistribute it and/or modify it under the terms of the GNU
% General Public License as published by the Free Software Foundation; either version 3 of the
% License, or any later version. This program is distributed in the hope that it will be useful, but
% WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
% PARTICULAR PURPOSE. See the GNU General Public License for more details. You should have received
% a copy of the GNU General Public License along with this program; if not, write to the Free
% Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

%---------------------------------------------------------------------------------------------------

% structure ud : champ UserData
%     HMenuImages		: handle menu Images
%     PointeurInfo	: false || true si pointeur = getinfo au lieu de flche

% champ UserData des uimenus  = rpertoire du fichier pour outils et module

%---------------------------------------------------------------------------------------------------

global ISAACPREF
global ISAACCONST

% figure(position en haut  gauche de l'cran)
% longueur de la barre de menus initialise  la valeur mini (6 menus)
% invisible jusqu' l'initialisation
longdim = 360;
h0 = figure( ...
	'CloseRequestFcn','IsaacMenuBar_cb CloseBox', ...
	'Name',[ISAACCONST.Info.IsaacName,' ',ISAACCONST.Info.IsaacVersion], ...
	'Tag','IsaacMenuBar', ...
	'Visible','off');

IsaacDefaultProperties(h0)

% menu Isaac
h1 = uimenu('Parent',h0, ...
	'Callback','IsaacMenuBar_cb MajMenuIsaac', ...
	'Label','Isaac', ...
	'Position',1, ...
	'Tag','MenuIsaac');
% About
uimenu('Parent',h1, ...
	'Callback','IsaacMenuBar_cb MItemAbout', ...
	'Label','A propos d''Isaac...', ...
	'Position',1);
% Prfrences
uimenu('Parent',h1, ...
	'Callback','IsaacMenuBar_cb MItemPrefs', ...
	'Label','Prfrences...', ...
	'Position',2, ...
	'Separator','on');
% PointeurInfo
uimenu('Parent',h1, ...
	'Callback','IsaacMenuBar_cb MItemPointeurInfo', ...
	'Checked','off', ...
	'Label','Pointeur info', ...
	'Position',3, ...
	'Separator','on', ...
	'Tag','MItemPointeurInfo');
% Mode Bavard
uimenu('Parent',h1, ...
	'Callback','IsaacMenuBar_cb MItemModeBavard', ...
	'Checked','off', ...
	'Label','Mode bavard', ...
	'Position',4, ...
	'Tag','MItemModeBavard');
% Quitter
uimenu('Parent',h1, ...
	'Callback','IsaacMenuBar_cb MItemQuit', ...
	'Label','Quitter', ...
	'Position',5, ...
	'Separator','on');

% menu Fichier
h1 = uimenu('Parent',h0, ...
	'Callback','IsaacMenuBar_cb MajMenuFile', ...
	'Label','Fichier', ...
	'Position',2, ...
	'Tag','MenuFile');
% Nouvelle Image
uimenu('Parent',h1, ...
	'Callback','IsaacMenuBar_cb MItemNewImage', ...
	'Label','Nouvelle image...', ...
	'Position',1);
% Import Image
uimenu('Parent',h1, ...
	'Callback','IsaacMenuBar_cb MItemImportImage', ...
	'Label','Importer...', ...
	'Position',2);
% Ouvrir Image
uimenu('Parent',h1, ...
	'Callback','IsaacMenuBar_cb MItemOpenImage', ...
	'Label','Ouvrir image...', ...
	'Position',3, ...
	'Separator','on');
% Ouvrir Serie
uimenu('Parent',h1, ...
	'Callback','IsaacMenuBar_cb MItemOpenSerie', ...
	'Label','Ouvrir srie...', ...
	'Position',4);
% Save image
uimenu('Parent',h1, ...
	'Callback','IsaacMenuBar_cb MItemSaveImage', ...
	'Enable','off', ...
	'Label','Sauver', ...
	'Position',5, ...
	'Separator','on', ...
	'Tag','MItemSaveImage');
% Save image As
uimenu('Parent',h1, ...
	'Callback','IsaacMenuBar_cb MItemSaveImageAs', ...
	'Enable','off', ...
	'Label','Sauver sous...', ...
	'Position',6, ...
	'Tag','MItemSaveImageAs');
% Restaurer image
uimenu('Parent',h1, ...
	'Callback','IsaacMenuBar_cb MItemRestaureImage', ...
	'Enable','off', ...
	'Label','Restaurer', ...
	'Position',7, ...
	'Separator','on', ...
	'Tag','MItemRestaureImage');
		
% menu Outils
h1 = uimenu('Parent',h0, ...
	'Label','Outils', ...
	'Position',3, ...
	'Tag','MenuOutils');
% Items
IsaacMenuBar_addtools(ISAACCONST.ToolsDir,h1,1,false)
nextpos = 4;

% menu Mes outils
if ~isempty(ISAACPREF.UserToolsDir)
	h1 = uimenu('Parent',h0, ...
		'Label','Mes outils', ...
		'Position',nextpos, ...
		'Tag','MenuMesOutils');
	% Items
	IsaacMenuBar_addtools(ISAACPREF.UserToolsDir,h1,1,false)
	nextpos = nextpos + 1;
	longdim = longdim + 80;
end

% menu Modules
h1 = uimenu('Parent',h0, ...
 	'Label','Modules', ...
 	'Position',nextpos , ...
	'Tag','MenuModules');
% Items
IsaacMenuBar_majmods(ISAACCONST.ModsDir,h1,1,false);
nextpos = nextpos + 1;

% menu Mes modules
if ~isempty(ISAACPREF.UserModsDir)
	h1 = uimenu('Parent',h0, ...
		'Label','Mes modules', ...
		'Position',nextpos , ...
		'Tag','MenuMesModules');
	% Items
	IsaacMenuBar_majmods(ISAACPREF.UserModsDir,h1,1,false);
	nextpos = nextpos + 1;
	longdim = longdim + 90;
end			

% menu Images ouvertes
ud.HMenuImages = uimenu('Parent',h0, ...
	'Label','Images', ...
	'Position',nextpos);
nextpos = nextpos + 1;
    
% menu Dveloppement
if ((ISAACPREF.Mode == 2) || (ISAACPREF.Mode == 3))
	h1 = uimenu('Parent',h0, ...
		'Callback','IsaacMenuBar_cb MajMenuDevelop', ...
		'Label','Dveloppement', ...
		'Position',nextpos, ...
		'Tag','MenuDevelop');
	% Disp Event
	uimenu('Parent',h1, ...
		'Callback','IsaacMenuBar_cb MItemDispEvent', ...
		'Checked','off', ...
		'Label','Afficher les vnements mis', ...
		'Position',1, ...
		'Tag','MItemDispEvent');
	% Liste Modules
	uimenu('Parent',h1, ...
		'Callback','IsaacMenuBar_cb MItemListMod', ...
		'Label','Liste des modules', ...
		'Position',2);
	% Reload Modules
	uimenu('Parent',h1, ...
		'Callback','IsaacMenuBar_cb MItemReloadMod', ...
		'Label','Recharger les modules', ...
		'Position',3, ...
		'Separator','on');
	% Reload Tools
	uimenu('Parent',h1, ...
		'Callback','IsaacMenuBar_cb MItemReloadTools', ...
		'Label','Recharger les outils', ...
		'Position',4);
	% Liste Fonctions
	uimenu('Parent',h1, ...
		'Callback','IsaacMenuBar_cb MItemListFun', ...
		'Label','Liste des fonctions en mmoire', ...
		'Position',5, ...
		'Separator','on');
	% Clear Fonctions
	uimenu('Parent',h1, ...
		'Callback','IsaacMenuBar_cb MItemClearFun', ...
		'Label','Effacer les fonctions en mmoire', ...
		'Position',6);
	% List Variables
	uimenu('Parent',h1, ...
		'Callback','IsaacMenuBar_cb MItemListVar', ...
		'Label','Liste des variables en mmoire', ...
		'Position',7, ...
		'Separator','on');
	% Clear Variables
	uimenu('Parent',h1, ...
		'Callback','IsaacMenuBar_cb MItemClearVar', ...
		'Label','Effacer les variables en mmoire', ...
		'Position',8);
	% Clear ParamMem
	uimenu('Parent',h1, ...
		'Callback','IsaacMenuBar_cb MItemClearParamMem', ...
		'Label','Effacer ParamMem', ...
		'Position',9)
	% Clear Command Window
	uimenu('Parent',h1, ...
		'Callback','IsaacMenuBar_cb MItemClearComWin', ...
		'Label','Effacer la fentre de commande', ...
		'Position',10, ...
		'Separator','on');
	
	nextpos = nextpos + 1;
	longdim = longdim + 120;
end	

% menu Aide
h1 = uimenu('Parent',h0, ...
 	'Label','Aide', ...
 	'Position',nextpos);
% Documentation
uimenu('Parent',h1, ...
	'Callback','IsaacMenuBar_cb MItemDoc', ...
	'Label','Documentation', ...
	'Position',1);
% Email
uimenu('Parent',h1, ...
	'Callback','IsaacMenuBar_cb MItemAuteur', ...
	'Label','Contacter l''auteur...', ...
	'Position',2, ...
	'Separator','on');
% Web 1
uimenu('Parent',h1, ...
	'Callback','IsaacMenuBar_cb MItemWeb1', ...
	'Label','Site web institutionnel', ...
	'Position',3);
% Web 2
uimenu('Parent',h1, ...
	'Callback','IsaacMenuBar_cb MItemWeb2', ...
	'Label','GitHub', ...
	'Position',4);

%---------------------------------------------------------------------------------------------------

% Initialisation
ud.PointeurInfo = false;
set(h0,'UserData',ud)
IsaacEventUpdListe(h0,ISAACCONST.ProgDir,'IsaacMenuBar_upd') % abonnement aux vnements
% dimensionnement et visibilit de la barre de menu
set(h0,'Position',IsaacFenPos(5,0,longdim,1,1),'Visible','on')
