function IsaacNewImage_cb(choix)
% Callback IsaacNewImage
%
% OpenIsaac
%  2018 Alain Clment - Universit d'Angers

%---------------------------------------------------------------------------------------------------

% Copyright 2007 - 2018 Universit d'Angers - Author: Alain Clment
%
% This program is free software; you can redistribute it and/or modify it under the terms of the GNU
% General Public License as published by the Free Software Foundation; either version 3 of the
% License, or any later version. This program is distributed in the hope that it will be useful, but
% WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
% PARTICULAR PURPOSE. See the GNU General Public License for more details. You should have received
% a copy of the GNU General Public License along with this program; if not, write to the Free
% Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

%---------------------------------------------------------------------------------------------------

global ISAACPRIV
global ISAACPREF
global ISAACCONST

switch(choix)
case 'Rad1'
	v = get(gcbo,'Value');
	if v == 1 % tait  0 et vient d'tre mis  1
		ud = get(gcbf,'UserData');
		ud.Nbb = 1;
		set(findobj(gcbf,'Tag','Rad8'),'Value',0)
		set(findobj(gcbf,'Tag','Rad16'),'Value',0)
		set(findobj(gcbf,'Tag','Rad32'),'Value',0)
		set(findobj(gcbf,'Tag','Rad64'),'Value',0)
		ud = IsaacNewImage_maj(gcbf,ud,'NbBits');
		set(gcbf,'UserData',ud)
	else % tait  1 et vient d'tre mis  0
		set(gcbo,'Value',1)	
	end		
case 'Rad8'
	v = get(gcbo,'Value');
	if v == 1 % tait  0 et vient d'tre mis  1
		ud = get(gcbf,'UserData');
		ud.Nbb = 8;
		set(findobj(gcbf,'Tag','Rad1'),'Value',0)
		set(findobj(gcbf,'Tag','Rad16'),'Value',0)
		set(findobj(gcbf,'Tag','Rad32'),'Value',0)
		set(findobj(gcbf,'Tag','Rad64'),'Value',0)
		ud = IsaacNewImage_maj(gcbf,ud,'NbBits');
		set(gcbf,'UserData',ud)
	else % tait  1 et vient d'tre mis  0
		set(gcbo,'Value',1)	
	end	
case 'Rad16'
	v = get(gcbo,'Value');
	if v == 1 % tait  0 et vient d'tre mis  1
		ud = get(gcbf,'UserData');
		ud.Nbb = 16;
		set(findobj(gcbf,'Tag','Rad1'),'Value',0)
		set(findobj(gcbf,'Tag','Rad8'),'Value',0)
		set(findobj(gcbf,'Tag','Rad32'),'Value',0)
		set(findobj(gcbf,'Tag','Rad64'),'Value',0)
		ud = IsaacNewImage_maj(gcbf,ud,'NbBits');
		set(gcbf,'UserData',ud)
	else % tait  1 et vient d'tre mis  0
		set(gcbo,'Value',1)	
	end
case 'Rad32'
	v = get(gcbo,'Value');
	if v == 1 % tait  0 et vient d'tre mis  1
		ud = get(gcbf,'UserData');
		ud.Nbb = 32;
		set(findobj(gcbf,'Tag','Rad1'),'Value',0)
		set(findobj(gcbf,'Tag','Rad8'),'Value',0)
		set(findobj(gcbf,'Tag','Rad16'),'Value',0)
		set(findobj(gcbf,'Tag','Rad64'),'Value',0)
		ud = IsaacNewImage_maj(gcbf,ud,'NbBits');
		set(gcbf,'UserData',ud)
	else % tait  1 et vient d'tre mis  0
		set(gcbo,'Value',1)	
	end	
case 'Rad64'
	v = get(gcbo,'Value');
	if v == 1 % tait  0 et vient d'tre mis  1
		ud = get(gcbf,'UserData');
		ud.Nbb = 64;
		set(findobj(gcbf,'Tag','Rad1'),'Value',0)
		set(findobj(gcbf,'Tag','Rad8'),'Value',0)
		set(findobj(gcbf,'Tag','Rad16'),'Value',0)
		set(findobj(gcbf,'Tag','Rad32'),'Value',0)
		ud = IsaacNewImage_maj(gcbf,ud,'NbBits');
		set(gcbf,'UserData',ud)
	else % tait  1 et vient d'tre mis  0
		set(gcbo,'Value',1)	
	end	
case 'EtxtDimX'
	ud = get(gcbf,'UserData');
	vstr = get(gcbo,'String');
	v = round(str2double(vstr));
	if(isnan(v) || ~isequal(size(v),[1 1]) || (v < 2))
		% (ordre des termes du if important au cas ou v de dim >1)
		% largeur mini d'une image = 2
		IsaacSound('Buzz')
		set(gcbo,'String',num2str(ud.DimX))
	else
		set(gcbo,'String',num2str(v))
		ud.DimX = v;
		set(gcbf,'UserData',ud);
	end	
case 'EtxtDimY'
	ud = get(gcbf,'UserData');
	vstr = get(gcbo,'String');
	v = round(str2double(vstr));
	if(isnan(v) || ~isequal(size(v),[1 1]) || (v < 2))
		% (ordre des termes du if important au cas ou v de dim >1)
		% hauteur mini d'une image = 2
		IsaacSound('Buzz')
		set(gcbo,'String',num2str(ud.DimY))
	else
		set(gcbo,'String',num2str(v))
		ud.DimY = v;
		set(gcbf,'UserData',ud);
	end	
case 'EtxtDimZ'
	ud = get(gcbf,'UserData');
	vstr = get(gcbo,'String');
	v = round(str2double(vstr));
	if(isnan(v) || ~isequal(size(v),[1 1]) || (v < 1) || (v > ISAACPREF.ImMaxPlans))
		% (ordre des termes du if important au cas ou v de dim >1)
		IsaacSound('Buzz')
		set(gcbo,'String',num2str(ud.DimZ))
	else
		set(gcbo,'String',num2str(v))
		if v > length(ud.Val)
			switch ud.Nbb
				case 1
					ud.Val(end+1:v) = false;
				case 8
					ud.Val(end+1:v) = uint8(0);
				case 16
					ud.Val(end+1:v) = uint16(0);
				case 32
					ud.Val(end+1:v) = single(0);
				case 64
					ud.Val(end+1:v) = double(0);
			end		
		elseif v < length(ud.Val)
			ud.Val(v+1:end) = [];
		end
		ud.DimZ = v;
		set(gcbf,'UserData',ud);
		s = cell(ud.DimZ,1);
		for i = 1:ud.DimZ
			s{i} = num2str(i);
		end
		h = findobj(gcbf,'Tag','PopupPlan');
		set(h,'String',s);
		v = get(h,'Value');
		if v > ud.DimZ
			set(h,'Value',ud.DimZ);
			set(findobj(gcbf,'Tag','EtxtVal'),'String',num2str(ud.Val(ud.DimZ)))
		end	
		if ud.DimZ == 1
			set(h,'Enable','off')
		else
			set(h,'Enable','on')
		end	
	end	
case 'PopupPlan'
	ud = get(gcbf,'UserData');
	v = get(gcbo,'Value');
	set(findobj(gcbf,'Tag','EtxtVal'),'String',num2str(ud.Val(v)));
case 'EtxtVal'
	ud = get(gcbf,'UserData');
	vstr = get(gcbo,'String');
	switch ud.Nbb
		case 1
			v = round(str2double(vstr));
			ok = (~isnan(v) && isequal(size(v),[1 1]) && (v == 0 || v == 1));
		case 8
			v = round(str2double(vstr));
			ok = (~isnan(v) && isequal(size(v),[1 1]) && v >= 0 && v <= 255);
		case 16
			v = round(str2double(vstr));
			ok = (~isnan(v) && isequal(size(v),[1 1]) && v >= 0 && v <= 65535);
		case {32,64}
			v = str2double(vstr);
			ok = (~isnan(v) && isequal(size(v),[1 1]) && v >= 0 && v <= 1);
	end
	if ~ok
		IsaacSound('Buzz')
		set(gcbo,'String',num2str(ud.Val(get(findobj(gcbf,'Tag','PopupPlan'),'Value'))))
	else
		switch ud.Nbb
			case 1
				ud.Val(get(findobj(gcbf,'Tag','PopupPlan'),'Value')) = logical(v);
			case 8
				ud.Val(get(findobj(gcbf,'Tag','PopupPlan'),'Value')) = uint8(v);
			case 16
				ud.Val(get(findobj(gcbf,'Tag','PopupPlan'),'Value')) = uint16(v);
			case 32
				ud.Val(get(findobj(gcbf,'Tag','PopupPlan'),'Value')) = single(v);
			case 64
				ud.Val(get(findobj(gcbf,'Tag','PopupPlan'),'Value')) = double(v);
		end
		set(findobj(gcbf,'Tag','EtxtVal'),'String',num2str(v));
		set(gcbf,'UserData',ud);
	end
case 'ButCancel'
	closereq
case 'ButOk'
	ud = get(gcbf,'UserData');
	try
		img = zeros(ud.DimY,ud.DimX,ud.DimZ);
		for i = 1:ud.DimZ
			img(:,:,i) = repmat(ud.Val(i),[ud.DimY ud.DimX]);		
		end
		% le rsultat est double (ne dpend pas du type de ud.Val mais de img)
		switch ud.Nbb
			case 1
				img2 = logical(img);
			case 8
				img2 = uint8(img);
			case 16
				img2 = uint16(img);
			case 32
				img2 = single(img);
			case 64
				img2 = double(img);
		end
		if (ud.DimZ == 3) && ismember(ud.Nbb,[8,16,64])
			colorspace = IsaacECOL('SRGB','D65');
		else
			colorspace = [];
		end
		ISAACPRIV.NewImgIdx = ISAACPRIV.NewImgIdx + 1;
		IsaacImage(gcbf,img2,['SansTitre-',num2str(ISAACPRIV.NewImgIdx)],[],colorspace);
		save(fullfile(ISAACCONST.PrefDir,'NewImagePrefs.mat'),'ud')
		figure(gcbf)
		closereq
	catch exception
		IsaacMessageErreur(IsaacError(exception))
	end
end	
	