function IsaacMenuBar_majmods(rep,menuhnd,startpos,separator)
% Ajoute les modules enregistrs dans le tableau ISAACPRIV.TabMod et issus du rpertoire rep  
% comme sous-menus (Mod_), sous-sous-menus (M_) dans le menu menuhnd  partir de startpos
% avec un sparateur si separator = true
% (partag par IsaacMenuBar et IsaacMenuBar_cb)
%
% NB : Dans ISAACPRIV.TabMod les modules sont classs par ordre alphabtique de chemin
%      => les modules d'un mme sous-rpertoire sont rangs conscutivement 
%
% OpenIsaac
%  2018 Alain Clment - Universit d'Angers

%---------------------------------------------------------------------------------------------------

% Copyright 2007 - 2018 Universit d'Angers - Author: Alain Clment
%
% This program is free software; you can redistribute it and/or modify it under the terms of the GNU
% General Public License as published by the Free Software Foundation; either version 3 of the
% License, or any later version. This program is distributed in the hope that it will be useful, but
% WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
% PARTICULAR PURPOSE. See the GNU General Public License for more details. You should have received
% a copy of the GNU General Public License along with this program; if not, write to the Free
% Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

%---------------------------------------------------------------------------------------------------

global ISAACPRIV

atrouver = fullfile(rep,'Mod'); % pas algorithmes
n1 = 0;
lastMod = '';
lastM = '';
for i = 1:ISAACPRIV.NbMod
	if strfind(ISAACPRIV.TabMod(i).dirname,atrouver)
		[parentdir,name] = fileparts(ISAACPRIV.TabMod(i).dirname);
		isM = strncmp(name,'M_',2);
		if isM
			% rep/Mod_modname/M_mname
			mname = name(3:end);
			[~,name] = fileparts(parentdir);
			modname = name(5:end);
		else
			% rep/Mod_modname
			modname = name(5:end);
		end
		if ~strcmp(modname,lastMod)
			lastMod = modname;
			n1 = n1+1;
			h1 = uimenu('Parent',menuhnd,'Label',modname,'Position',startpos+n1-1);
			if ((n1 == 1) && separator)
				set(h1,'Separator','on');
			end
			n2 = 0;
			n3 = 0;
		end
		if isM
			if ~strcmp(mname,lastM)
				lastM = mname;
				n2 = n2+1;
				h2 = uimenu('Parent',h1,'Label',mname,'Position',n2);
				n3 = 0;
			end
			parenthnd = h2;
		else
			parenthnd = h1;
		end	
		n3 = n3+1;
		uimenu('Parent',parenthnd, ...
			'Callback','IsaacMenuBar_cb MItemModule', ...
			'Label',ISAACPRIV.TabMod(i).filename, ...
			'Position',n3, ...
			'Tag',ISAACPRIV.TabMod(i).filename, ...
			'UserData',ISAACPRIV.TabMod(i).dirname);
	end
end
