function IsaacModBox_majopt(fighnd,codeop)
% affichage des options du paramtre slectionn dans IsaacModBox
% (partag par IsaacModBox et IsaacModBox_cb)
%
% fighnd = handle de la fentre IsaacModBox
%
%	- codeop = 0 
%		=> affichage des options pour le paramtre en cours d'dition avec maj de
%		l'option slectionne
%	- 1 <= codeop <= 5
%		=> maj de l'option slectionne pour le paramtre en cours d'dition
%
%		1 : valeur variable Base Workspace (@IsaacDATA uniquement)
%		2 : image cible
%		3 : mmoire
%		4 : fichier
%		5 : MATLAB
%
% OpenIsaac
%  2018 Alain Clment - Universit d'Angers

%---------------------------------------------------------------------------------------------------
% Copyright 2007 - 2018 Universit d'Angers - Author: Alain Clment
%
% This program is free software; you can redistribute it and/or modify it under the terms of the GNU
% General Public License as published by the Free Software Foundation; either version 3 of the
% License, or any later version. This program is distributed in the hope that it will be useful, but
% WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
% PARTICULAR PURPOSE. See the GNU General Public License for more details. You should have received
% a copy of the GNU General Public License along with this program; if not, write to the Free
% Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

%---------------------------------------------------------------------------------------------------

global ISAACPREF

ud = get(fighnd,'UserData');
if ud.PIndex(1) % il y a des paramtres
	param = ud.Param{ud.PIndex(1)}(ud.PIndex(2));
end
if (codeop == 0)
	% affichage/effacement des options
	set(findobj(fighnd,'Tag','RadButParamWS'),'Enable','off','Value',0)
	set(findobj(fighnd,'Tag','RadButParamCible'),'Enable','off','Value',0)
	set(findobj(fighnd,'Tag','RadButParamMem'),'Enable','off','Value',0)
	set(findobj(fighnd,'Tag','RadButParamFich'),'Enable','off','Value',0)
	set(findobj(fighnd,'Tag','RadButParamMATLAB'),'Enable','off','Value',0)
	if ud.PTarget
		if ismember(1,param.options)
			set(findobj(fighnd,'Tag','RadButParamWS'),'Enable','on')
		end	
		if ismember(2,param.options)
			set(findobj(fighnd,'Tag','RadButParamCible'),'Enable','on')
		end	
		if ismember(3,param.options)
			set(findobj(fighnd,'Tag','RadButParamMem'),'Enable','on')
		end
		if ismember(4,param.options)
			set(findobj(fighnd,'Tag','RadButParamFich'),'Enable','on')
		end
		if ismember(5,param.options)
			set(findobj(fighnd,'Tag','RadButParamMATLAB'),'Enable','on')
		end
		switch ud.PTarget
			case 1
				set(findobj(fighnd,'Tag','RadButParamWS'),'Value',1)
			case 2
				set(findobj(fighnd,'Tag','RadButParamCible'),'Value',1)
			case 3
				set(findobj(fighnd,'Tag','RadButParamMem'),'Value',1)
			case 4
				set(findobj(fighnd,'Tag','RadButParamFich'),'Value',1)
			case 5
				set(findobj(fighnd,'Tag','RadButParamMATLAB'),'Value',1)
		end
		codeop = ud.PTarget; % pour affichage de l'option slectionne
	else
		set(findobj(fighnd,'Tag','EtxtWSVarname'),'Visible','off')
		set(findobj(fighnd,'Tag','EtxtVarname'),'Visible','off')
		set(findobj(fighnd,'Tag','StxtTargetInfo'),'String','')
		set(findobj(fighnd,'Tag','ButParamValider'),'Enable','off')
	end	
end	
switch codeop
	% affichage de l'option slectionne
	case 1
		% base workspace variable
		set(findobj(fighnd,'Tag','EtxtWSVarname'),'Visible','on')
		set(findobj(fighnd,'Tag','EtxtVarname'),'Visible','off')
		set(findobj(fighnd,'Tag','StxtTargetInfo'),'String','')
		set(findobj(fighnd,'Tag','ButParamValider'),'Enable','on')
	case 2	
		% image cible
		set(findobj(fighnd,'Tag','EtxtWSVarname'),'Visible','off')
		set(findobj(fighnd,'Tag','EtxtVarname'),'Visible','off')
		cible = IsaacImageCible;
		if isempty(cible)
			set(findobj(fighnd,'Tag','ButParamValider'),'Enable','off')
			set(findobj(fighnd,'Tag','StxtTargetInfo'),'ForegroundColor',ISAACPREF.TextColor3, ...
				'String','pas d''image cible')
		else
			set(findobj(fighnd,'Tag','ButParamValider'),'Enable','on')
			set(findobj(fighnd,'Tag','StxtTargetInfo'),'ForegroundColor',ISAACPREF.TextColor1, ...
				'String',IsaacImage_get(cible,'Name'))
		end
	case {3,4}
		% mmoire ou fichier
		set(findobj(fighnd,'Tag','EtxtWSVarname'),'Visible','off')
		set(findobj(fighnd,'Tag','EtxtVarname'),'Visible','off')
		set(findobj(fighnd,'Tag','StxtTargetInfo'),'String','')
		set(findobj(fighnd,'Tag','ButParamValider'),'Enable','on')
	case 5
		% MATLAB
		set(findobj(fighnd,'Tag','EtxtWSVarname'),'Visible','off')
		set(findobj(fighnd,'Tag','EtxtVarname'),'Visible','on')
		set(findobj(fighnd,'Tag','StxtTargetInfo'),'String','')
		set(findobj(fighnd,'Tag','ButParamValider'),'Enable','on')
	end	
end
