function ud = IsaacNewImage_maj(fighnd,ud,varargin)
% Mise  jour de l'affichage dans IsaacNewImage
% (partag par IsaacNewImage et IsaacNewImage_cb)
%
%	ud = IsaacNewImage_maj(fighnd,ud,maj1,...,majN)
%
% - fighnd	: handle figure IsaacNewImage
% - ud		: champ UserData de IsaacNewImage
%
%	propname			
%	--------
%	'NbBits' : suite initialisation ou changement du nb de bits
%
% OpenIsaac
%  2018 Alain Clment - Universit d'Angers

%---------------------------------------------------------------------------------------------------

% Copyright 2007 - 2018 Universit d'Angers - Author: Alain Clment
%
% This program is free software; you can redistribute it and/or modify it under the terms of the GNU
% General Public License as published by the Free Software Foundation; either version 3 of the
% License, or any later version. This program is distributed in the hope that it will be useful, but
% WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
% PARTICULAR PURPOSE. See the GNU General Public License for more details. You should have received
% a copy of the GNU General Public License along with this program; if not, write to the Free
% Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

%---------------------------------------------------------------------------------------------------

if (nargin < 3)
	error('nombre d''arguments incorrect')
end
propargin = varargin;
while ~isempty(propargin)
	propname = propargin{1};
	propargin = propargin(2:end);
	switch propname
		case 'NbBits'
			UpdateBits
		otherwise
			error('argument incorrect')
	end
end
			
% --- Nested fonction ------------------------------------------------------------------------------

function UpdateBits
	
switch ud.Nbb
	case 1
		set(findobj(fighnd,'Tag','StxtVal'),'String','Valeur binaire {0,1} :')
		ud.Val = logical(ud.Val);
	case 8
		set(findobj(fighnd,'Tag','StxtVal'),'String','Valeur {0...255} :')
		ud.Val = im2uint8(ud.Val);
	case 16
		set(findobj(fighnd,'Tag','StxtVal'),'String','Valeur {0...65535} :')
		ud.Val = im2uint16(ud.Val);
	case 32
		set(findobj(fighnd,'Tag','StxtVal'),'String','Valeur relle [0,1] :')
		ud.Val = im2single(ud.Val);
	case 64
		set(findobj(fighnd,'Tag','StxtVal'),'String','Valeur relle [0,1] :')
		ud.Val = im2double(ud.Val);
end
set(findobj(fighnd,'Tag','EtxtVal'),'String', ...
	num2str(ud.Val(get(findobj(fighnd,'Tag','PopupPlan'),'Value'))));

end % fin nested fonction

%---------------------------------------------------------------------------------------------------

end % fin IsaacNewImage_maj en raison des nested fonctions

		